<template>
	<xn-form-container
		:title="formData.id ? '编辑咨询类型' : '增加咨询类型'"
		:width="700"
		:visible="visible"
		:destroy-on-close="true"
		@close="onClose"
	>
		<a-form ref="formRef" :model="formData" :rules="formRules" layout="vertical">
			<a-row :gutter="16">
				<a-col :span="14">
					<a-form-item label="类型名称：" name="name">
						<a-input v-model:value="formData.name" placeholder="请输入类型名称" allow-clear/>
					</a-form-item>
				</a-col>

				<a-col :span="14">
					<a-form-item label="排序：" name="sort">
						<a-input-number v-model:value="formData.sort" placeholder="请输入排序"
										style="width: 100%;" :min="1" :max="1000"/>
					</a-form-item>
				</a-col>
			</a-row>
		</a-form>
		<template #footer>
			<a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
			<a-button type="primary" @click="onSubmit" :loading="submitLoading">保存</a-button>
		</template>
	</xn-form-container>
</template>

<script setup name="consultTypeForm">

import {cloneDeep} from 'lodash-es'
import {required} from '@/utils/formRules'
import consultTypeApi from '@/api/website/consultTypeApi'
// 抽屉状态
const visible = ref(false)
const emit = defineEmits({successful: null})
const formRef = ref()
// 表单数据
const formData = ref({})
const submitLoading = ref(false)

// 打开抽屉
const onOpen = (record) => {
	visible.value = true
	if (record) {
		let recordData = cloneDeep(record)
		formData.value = Object.assign({}, recordData)
	}
}
// 关闭抽屉
const onClose = () => {
	formRef.value.resetFields()
	formData.value = {}
	visible.value = false
}
// 默认要校验的
const formRules = {
	name: [required('请输入类型名称')],
	sort: [required("请输入排序")],
}
// 验证并提交数据
const onSubmit = () => {
	formRef.value.validate().then(() => {
		submitLoading.value = true
		const formDataParam = cloneDeep(formData.value)
		consultTypeApi.save(formDataParam, formDataParam.id)
			.then(() => {
				onClose()
				emit('successful')
			})
			.finally(() => {
				submitLoading.value = false
			})
	})
}
// 抛出函数
defineExpose({
	onOpen
})
</script>
